.tyui-button {
    background: none;
    border: none;
    cursor: pointer;
    min-height: 2.75rem;
    min-width: 2.75rem;
    padding: .5rem 1rem;
    font-weight: 700;
    font-size: 1rem;
    line-height: 1.25rem;
    transition-property: background, color, border;
    transition-duration: var(--transition-time);
    outline: none;
    border-radius: var(--border-radius);
}

.tyui-button--primary {
    background: var(--background-action-primary);
    color: var(--text-inverted-default);
}

.tyui-button--primary:hover {
    background: var(--background-action-primary--hover);
}

.tyui-button--primary:active {
    background: var(--background-action-primary--active);
}
.tyui-button--primary[aria-disabled="true"],
.tyui-button--primary[disabled]
{
    cursor: not-allowed;
    color: var(--text-disabled-grey);
    background: var(--background-disabled-grey);
}



.tyui-button--secondary {
    background: var(--background-default);
    color: var(--text-action-primary);
    box-shadow: inset 0 0 0 var(--border-width) var(--border-color-primary);
}

.tyui-button--secondary:hover {
    background: var(--background-default--hover);
}

.tyui-button--secondary:active {
    background: var(--background-default--active);
}
.tyui-button--secondary[aria-disabled="true"],
.tyui-button--secondary[disabled]
{
    cursor: not-allowed;
    box-shadow: inset 0 0 0 var(--border-width) var(--border-disabled-grey);
    color: var(--text-disabled-grey);
    background: var(--background-disabled-grey);
}


.tyui-button--tertiary {
    background: var(--background-default);
    color: var(--text-action-primary);
}

.tyui-button--tertiary:hover {
    background: var(--background-default--hover);
}

.tyui-button--tertiary:active {
    background: var(--background-default--active);
}
.tyui-button--tertiary[aria-disabled="true"],
.tyui-button--tertiary[disabled]
{
    cursor: not-allowed;
    color: var(--text-disabled-grey);
    background: var(--background-disabled-grey);
}



.tyui-button--danger {
    background: var(--background-action-error);
    color: var(--text-inverted-default);
}

.tyui-button--danger:hover {
    background: var(--background-action-error--hover);
}

.tyui-button--danger:active {
    background: var(--background-action-error--active);
}
.tyui-button--danger[aria-disabled="true"],
.tyui-button--danger[disabled]
{
    cursor: not-allowed;
    color: var(--text-disabled-grey);
    background: var(--background-disabled-grey);
}


.tyui-buttons-group {
    list-style-type: none;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    margin: 0 -.25rem;
    padding: 0;
    li {
        width: auto;
        max-width: 100%;
        .tyui-button {
            margin: 0 .25rem;
        }
    }
}

.tyui-button--icon {
    --icon-size: 1.5rem;
    max-width: 2.75rem;
    max-height: 2.75rem;
    padding: calc((2.75rem - var(--icon-size)) / 2);
    white-space: nowrap;
    overflow: hidden;
}

.tyui-button--icon:not(.tyui-button--icon-right)::before {
    content: "";
    mask-image: var(--icon-url);
    mask-size: 100% 100%;
    background-color: currentColor;
    display: inline-block;
    flex: 0 0 auto;
    height: var(--icon-size);
    width: var(--icon-size);
    vertical-align: calc((.75em - var(--icon-size))* .5);
    margin-right: calc((2.75rem - var(--icon-size)) / 2);
}

.tyui-button--icon-left, .tyui-button--icon-right {
    overflow: hidden;
    max-width: none;
    max-height: none;
}

.tyui-button--icon-right::after {
    content: "";
    mask-image: var(--icon-url);
    mask-size: 100% 100%;
    background-color: currentColor;
    display: inline-block;
    flex: 0 0 auto;
    height: var(--icon-size);
    width: var(--icon-size);
    vertical-align: calc((.75em - var(--icon-size))* .5);
    margin-left: calc((2.75rem - var(--icon-size)) / 2);
}